Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# TQAxBindable Class Reference
[TQAxServer module]

The TQAxBindable class provides an interface between a TQWidget and an ActiveX client. More...

This class is part of the TQt ActiveTQt Extension.

`#include <qaxbindable.h>`

List of all member functions.

## Public Members

- TQAxBindable ()
- virtual ~TQAxBindable ()
- virtual TQAxAggregated * createAggregate ()

## Static Public Members

- void reportError ( int code, const TQString & src, const TQString & desc, const TQString & context = TQString::null )

## Protected Members

- bool requestPropertyChange ( const char * property )
- void propertyChanged ( const char * property )
- IUnknown * clientSite () const

## Detailed Description

This class is defined in the TQt ActiveTQt Extension, which can be found in the `qt/extensions` directory. It is not included in the main TQt API.

The TQAxBindable class provides an interface between a TQWidget and an ActiveX client.

The functions provided by this class allow an ActiveX control to communicate property changes to a client application. Inherit your control class from both TQWidget (directly or indirectly) and this class to get access to this class's functions. The meta object compiler requires you to inherit from TQWidget first.

        class MyActiveX : public TQWidget, public TQAxBindable
        {
            TQ_OBJECT
            TQ_PROPERTY( int value READ value WRITE setValue )
        public:
            MyActiveX( TQWidget *parent = 0, const char *name = 0 );
            ...

            int value() const;
            void setValue( int );
        };

When implementing the property write function, use requestPropertyChange() to get permission from the ActiveX client application to change this property. When the property changes, call propertyChanged() to notify the ActiveX client application about the change. If a fatal error occurs in the control, use the static reportError() function to notify the client.

Use the interface returned by clientSite() to call the ActiveX client. To implement additional COM interfaces in your ActiveX control, reimplement createAggregate() to return a new object of a TQAxAggregated subclass.

## Member Function Documentation

### TQAxBindable::TQAxBindable ()

Constructs an empty TQAxBindable object.

### TQAxBindable::~TQAxBindable ()`[virtual]`

Destroys the TQAxBindable object.

### IUnknown * TQAxBindable::clientSite () const`[protected]`

Returns a pointer to the client site interface for this ActiveX object, or null if no client site has been set.

Call QueryInterface() on the returned interface to get the interface you want to call.

### TQAxAggregated * TQAxBindable::createAggregate ()`[virtual]`

Reimplement this function when you want to implement additional COM interfaces in the ActiveX control, or when you want to provide alternative implementations of COM interfaces. Return a new object of a TQAxAggregated subclass.

The default implementation returns the null pointer.

### void TQAxBindable::propertyChanged ( const char * property )`[protected]`

Call this function to notify the client that is hosting this ActiveX control that the property property has been changed.

This function is usually called at the end of the property's write function.

See also requestPropertyChange().

### void TQAxBindable::reportError ( int code, const TQString & src, const TQString & desc, const TQString & context = TQString::null )`[static]`

Reports an error to the client application. code is a control-defined error code. desc is a human-readable description of the error intended for the application user. src is the name of the source for the error, typically the ActiveX server name. context can be the location of a help file with more information about the error. If context ends with a number in brackets, e.g. [12], this number will be interpreted as the context ID in the help file.

### bool TQAxBindable::requestPropertyChange ( const char * property )`[protected]`

Call this function to request permission to change the property property from the client that is hosting this ActiveX control. Returns TRUE if the client allows the change; otherwise returns FALSE.

This function is usually called first in the write function for property, and writing is abandoned if the function returns FALSE.

        void MyActiveTQt::setText( const TQString &text )
        {
            if ( !requestPropertyChange( "text" ) )
                return;

            // update property

            propertyChanged( "text" );
        }

See also propertyChanged().

This file is part of the TQt toolkit. Copyright © 1995-2007 Trolltech. All Rights Reserved.